#include <Bounce.h>

/*============================================
 Robot, Endschalter vorne
 created 2011-09-03
 by Ingo Strecker, DL6IS
=============================================*/
 
int dirRight = 12;        // Motor A, Rechts   High = vorwärts  low = rückwärts
int dirLeft = 13;         // Motor B, Links
int speedRight = 10;      // Geschwindigkeit Motor Rechts 0 - 255
int speedLeft = 11;       // Geschwindigkeit Motor Links
int b2S1 = 7;
int StartEngine = LOW;
int speed =0;
int speedCorr = 60;        // für genauen Geradeauslauf - Li. Motor langsamer + li. Motor schneller
int BumperLeft = 3;
int BumperRight = 2;

Bounce bouncer = Bounce (b2S1, 5); 

void setup()
{
  pinMode (dirRight, OUTPUT);
  pinMode (dirLeft, OUTPUT);
  pinMode (speedRight, OUTPUT);
  pinMode (speedLeft, OUTPUT);
  pinMode (b2S1, INPUT);
  digitalWrite(b2S1, HIGH);          // Pull-Up-Widerstand aktivieren
  pinMode (BumperLeft, INPUT);
  digitalWrite (BumperLeft, HIGH);   // Pull-Up-Widerstand aktivieren
  pinMode (BumperRight, INPUT);
  digitalWrite (BumperRight, HIGH);  // Pull-Up-Widerstand aktivieren
}

void Forward (int speed) {
  digitalWrite(dirRight, HIGH);
  digitalWrite(dirLeft, HIGH);
  
  analogWrite (speedRight, speed);  
  speed=speed+speedCorr;             // Korrektur  der Laugeschwindigkeit des li. Motores
  analogWrite (speedLeft, speed);
}

void Backward (int speed) {
  digitalWrite(dirRight, LOW);
  digitalWrite(dirLeft, LOW);
  analogWrite (speedRight, speed);
  analogWrite (speedLeft, speed);
}

void Spin_Left (int speed) {
  analogWrite (speedLeft, speed);
}

void Spin_Right (int speed) {
  analogWrite (speedRight, speed);
}

void stopEngines() {
  analogWrite (speedRight, 0);
  analogWrite (speedLeft, 0);
}
  

void loop()
{
// Für Betrieb ohne Start/Stop-Taste, folgende Zeilen......
//  if (bouncer.update()) {
//    if (!bouncer.read()) {
//      StartEngine = StartEngine ^ 1;
//      if (StartEngine) {                  // Motoren starten
//        //Nothing to do here
 //     } else {                            // Motoren stoppen
   //   stopEngines();
//      }
//    }
//  }
// ......bis hierhin auskommentieren.
// Dafür diese Zeile aktivieren:
  StartEngine = 1;

  if (StartEngine) {
    Forward (100);
    if (!digitalRead (BumperLeft)) {  // Linker Endschalter betätigt
      stopEngines();
      Backward (100);
      delay (500);
      Spin_Right (255);
      Spin_Left (0);
      delay (500);
    }
    else if (!digitalRead (BumperRight)) {  // Rechter Endschalter betätigt
      stopEngines();
      Backward (100);
      delay (500);
      Spin_Right (0);
      Spin_Left (255);
      delay (500);
    }
  }
}
